package com.mcapraro.ld28
{
	import nape.geom.AABB;
	import citrus.view.starlingview.StarlingArt;
	import citrus.view.starlingview.AnimationSequence;
	import citrus.objects.platformer.box2d.Hero;

	/**
	 * @author Michelangelo Capraro (m&#64;mcapraro.com)
	 */
	public class BirdHero extends Hero
	{
		public function BirdHero(name:String, params:Object = null)
		{
			super(name, params);
		}
		
		
		override public function initialize(poolObjectParams:Object = null):void
		{
			super.initialize(poolObjectParams);
						
			view = AnimationSequence.fromMovieClip(new BirdAssets(), "idle", 30);
			
			StarlingArt.setLoopAnimations(["idle"]);
			
			hurtVelocityX = 
			hurtVelocityY = 0;

		}
		
		
		
		override protected function updateAnimation():void
		{
			var prevAnimation:String = _animation;
			
			var walkingSpeed:Number = getWalkingSpeed();
						
			if (_hurt)
				_animation = "pickup";
				
			else if (!_onGround) {
				
				_animation = "idle"; // need in-air art
				
				if (walkingSpeed < -acceleration)
					_inverted = true;
				else if (walkingSpeed > acceleration)
					_inverted = false;
				
			} else if (_ducking) {
				//_animation = "pickup";
				
			} else {
				
				if (walkingSpeed < -acceleration) {
					_inverted = true;
					_animation = "walk";
					
				} else if (walkingSpeed > acceleration) {
					
					_inverted = false;
					_animation = "walk";
					
				} else
					_animation = "idle";
			}
						
			if (prevAnimation != _animation) onAnimationChange.dispatch();
						
		}
		
		
		override public function destroy():void
		{
			super.destroy();
		}
		
		public function set inverted(value:Boolean):void 
		{
			_inverted = value;
		}
	
		
		
	}
}
