package com.mcapraro.ld28
{
	import flash.utils.Dictionary;
	import starling.core.Starling;
	import flash.geom.Matrix;
	import flash.display.BitmapData;
	import flash.display.Sprite;
	import starling.textures.Texture;
	import citrus.utils.AGameData;

	/**
	 * @author Michelangelo Capraro (m&#64;mcapraro.com)
	 */
	public class GameData extends AGameData
	{
		private var _levels:Array;
		private var _requiredItemCount:int;
		private var _items:Vector.<Class>;
		private var _requiredItems:Vector.<Class>;
		private var _itemTextures:Dictionary;
		private var _collectedItems:Vector.<Class>;
			
		
		public function GameData()
		{
			super();
			
			_levels = [Level1State];
			_items = new <Class>[CoinBerryAsset, CoinButtonAsset, CoinCapAsset, CoinLeafAsset, CoinMoneyAsset, CoinRockAsset, CoinShellAsset, CoinStringAsset, CoinTwigAsset];
			_itemTextures = new Dictionary();
			_requiredItemCount = 1;
			_collectedItems = new Vector.<Class>;
			_requiredItems = new Vector.<Class>;
			updateRequiredItems();
		}

		public function createTextureCache():void
		{
			var itemClass:Class;
			for (var i:int = 0; i < _items.length; i++) {
				itemClass = _items[i];
								
				var itemMC:flash.display.Sprite = new itemClass();
				var itemBMD:BitmapData = new BitmapData(64, 68, true, 0x00000000);
				itemBMD.draw(itemMC, new Matrix(1, 0, 0, 1, 32, 34));
				_itemTextures[itemClass] = Texture.fromBitmapData(itemBMD, false, false, Starling.contentScaleFactor);
			}
			
		}

		public function get levels():Array
		{
			return _levels;
		}

		public function get requiredItemCount():int
		{
			return _requiredItemCount;
		}

		public function set requiredItemCount(requiredItemCount:int):void
		{
			_requiredItemCount = requiredItemCount;
			_collectedItems = new Vector.<Class>;
			updateRequiredItems();
		}

		private function updateRequiredItems():void
		{
			var tempItems:Vector.<Class> = _items.concat();
			_requiredItems = new Vector.<Class>;
			for (var i:int = 0; i < _requiredItemCount; i++) {
				
				if (_requiredItemCount < 7) {	// for amounts of 6 and lower, pop items form the list so we always have unique ones
					_requiredItems.push(tempItems.splice(Math.ceil(Math.random() * (tempItems.length - 1)), 1)[0]);
					
				} else {				// for more items, we can have duplicates
					_requiredItems.push(tempItems[Math.ceil(Math.random() * (tempItems.length - 1))]);
				}
			}
		}

		public function get requiredItems():Vector.<Class>
		{
			return _requiredItems;
		}

		public function get items():Vector.<Class>
		{
			return _items;
		}

		public function get itemTextures():Dictionary
		{
			return _itemTextures;
		}
		
		public function collectItem(item:Class):void
		{
			_collectedItems.push(item);
		}
		
		public function validateCollectedItems():Boolean
		{
			var validation:Boolean = true;
			
			trace("GameData: validateCollectedItems: " + _collectedItems.length + ", " + _requiredItems.length);
			
			
			if (_collectedItems.length != _requiredItems.length) {
				// if the counts dont match, then its wrong automatically
				validation = false;
			} else {
				// now check to see if they got the right items
				for (var i:int = 0; i < _requiredItems.length; i++) {
					
					trace(_requiredItems[i] != _collectedItems[i]); 
					
					if (_requiredItems[i] != _collectedItems[i]) {
						validation = false;
						break;
					}
				}
			}
			return validation;
			
			
		}
	}
}
