package com.mcapraro.ld28
{
	import citrus.core.CitrusEngine;
	import starling.display.Image;
	import starling.display.Shape;
	import starling.events.Event;

	/**
	 * @author Michelangelo Capraro (m&#64;mcapraro.com)
	 */
	public class InventoryUI extends starling.display.Sprite
	{
		private const MARGIN:int = 6;
		private const UI_HEIGHT:int = 190;
		private var _itemCount:int;
		private var itemContainer:starling.display.Sprite;
		
		public function InventoryUI(itemCount:int)
		{
			_itemCount = itemCount;
			addEventListener(Event.ADDED_TO_STAGE, onAdded);
		}

		private function onAdded(event:Event):void
		{
			event;
			
			itemContainer = new starling.display.Sprite();
			var itemPlaceholder:Shape;
			for (var i:int = 0; i < _itemCount; i++) {
				itemPlaceholder = new Shape();
				itemPlaceholder.graphics.beginFill(0x000000, .1);
				itemPlaceholder.graphics.lineStyle(2, 0x231F20, 0);
				itemPlaceholder.graphics.drawRect(0, 0, 64, 68);
				itemPlaceholder.graphics.endFill();
				
				itemPlaceholder.x = (i % 12) * (64 + MARGIN);	
				itemPlaceholder.y = Math.floor(i / 12) * (68 + MARGIN);	

				itemContainer.addChild(itemPlaceholder);
			}
			
			itemContainer.x = (stage.stageWidth - itemContainer.width) / 2;
			itemContainer.y = stage.stageHeight - 190 + (UI_HEIGHT - itemContainer.height) / 2;
			addChild(itemContainer);
		}
		
		public function addItem(itemClass:Class):void
		{
			var itemImage:Image = itemContainer.addChild(new Image((CitrusEngine.getInstance().gameData as GameData).itemTextures[itemClass])) as Image;
			var itemIndex:int = itemContainer.numChildren - _itemCount - 1;
			itemImage.x = (itemIndex % 12) * (64 + MARGIN);	
			itemImage.y = Math.floor(itemIndex / 12) * (68 + MARGIN);		
			
		}
	}
}
