package com.mcapraro.ld28
{
	import starling.utils.AssetManager;
	import flash.events.Event;
	import starling.core.Starling;
	import citrus.core.starling.ViewportMode;
	import citrus.core.starling.StarlingCitrusEngine;

	
	[SWF(backgroundColor="#FFFFFF", frameRate="60", width="960", height="640")]
	/**
	 * @author Michelangelo Capraro (m&#64;mcapraro.com)
	 */
	public class Main extends StarlingCitrusEngine
	{
				
		public function Main()
		{
			
			_baseWidth = 960;
			_baseHeight = 640;
			_viewportMode = ViewportMode.FULLSCREEN;
			gameData = new GameData();
			
		}
		
		override protected function handleAddedToStage(e:Event):void
		{
			super.handleAddedToStage(e);
			
			Starling.multitouchEnabled = true;
			
			setUpStarling(true);
		}
		
		override public function handleStarlingReady():void
		{
			Assets.assets = new AssetManager(scaleFactor);
			
			Assets.assets.enqueue(Assets);
			
			/*
			Assets.assets.enqueue("multi-resolutions/assets" + scaleFactor + "x.png");
			Assets.assets.enqueue("multi-resolutions/assets" + scaleFactor + "x.xml");
			Assets.assets.enqueue("multi-resolutions/backgrounds" + scaleFactor + "x.png");
			Assets.assets.enqueue("multi-resolutions/backgrounds" + scaleFactor + "x.xml");
			*/
			Assets.assets.verbose = true;
			
			Assets.assets.loadQueue(function(ratio:Number):void
				{
					if (ratio == 1)
						onAssetsLoaded();
				});
			
			Starling.current.showStats = false;
			
		}

		private function onAssetsLoaded():void
		{
			(gameData as GameData).createTextureCache(); 
			loadState(true);
		}

		private function loadState(firstRun:Boolean = false):void
		{
			// state = new IntroState();
			state = new Level1State(firstRun);
			Level1State(state).onRestart.add(onRestart);
		}

		private function onRestart(itemCount:int):void
		{
			(gameData as GameData).requiredItemCount = itemCount;
			loadState();
		}

	}
}
