package com.mcapraro.ld28
{
	import starling.display.Image;
	import starling.core.Starling;
	import starling.display.BlendMode;
	import starling.textures.Texture;
	import citrus.view.starlingview.StarlingTileSystem;
	import citrus.objects.CitrusSprite;

	/**
	 * @author Michelangelo Capraro (m&#64;mcapraro.com)
	 */
	public class TiledBackground extends CitrusSprite
	{
		private var gridTileSystem:StarlingTileSystem;
		public var texture:String;
		public var blendMode:String = BlendMode.AUTO;
		public var alpha:Number = 1;
		private var backgroundTile:Texture;
		private var gridTiles:Array;
		
		public function TiledBackground(name:String, params:Object = null)
		{
			super(name, params);
			
			gridTiles = [];
			var rowTiles:Array;
			backgroundTile = Assets.assets.getTexture(texture); // if we do this, we only have one bitmap in memory

			var gridWidth:int = Math.ceil(width / backgroundTile.width);
			var gridHeight:int = Math.ceil(height / backgroundTile.height);
			
			for (var rowIdx:int = 0; rowIdx < gridHeight ; rowIdx++) {
				rowTiles = new Array();
				for (var colIdx:int = 0; colIdx < gridWidth; colIdx++) {
					rowTiles.push(backgroundTile);
				}
				gridTiles.push(rowTiles); 
			}

			gridTileSystem = new StarlingTileSystem(gridTiles);
			gridTileSystem.name = name;
			gridTileSystem.blendMode = blendMode;
			gridTileSystem.touchable = false;
			gridTileSystem.alpha = alpha;
			gridTileSystem.init();
			//Starling.current.stage.addChild(new Image(backgroundTile));			
			_view = gridTileSystem;
			
			//_offsetX = -width / 2;
			//_offsetY = -height / 2;
		
			
		}
		
		
		override public function destroy():void
		{
			super.destroy();
			gridTiles = null;
			//backgroundTile.dispose();
		}
		
		


	}
}
